// DialogChosePort.cpp : implementation file
//

#include "stdafx.h"
#include "tstmodem.h"
#include "DialogChosePort.h"


// CDialogChosePort dialog

IMPLEMENT_DYNAMIC(CDialogChosePort, CDialog)

CDialogChosePort::CDialogChosePort(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogChosePort::IDD, pParent)
{

}

CDialogChosePort::~CDialogChosePort()
{
}

void CDialogChosePort::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_PORT, m_ComboPort);
	DDX_Control(pDX, IDC_COMBO_SPEED, m_ComboSpeed);
	DDX_Control(pDX, IDC_COMBO_DATABITS, m_ComboDatabits);
}

BOOL CDialogChosePort::OnInitDialog()
{
	CDialog::OnInitDialog();

	CStringArray *pStrArray;
	int i;
 
	pStrArray = SerialParams::GetDeviceList();
	for (i=0; i< pStrArray->GetSize();i++)
		m_ComboPort.AddString(pStrArray->GetAt(i));

	pStrArray = SerialParams::GetSpeedList();
	for (i=0; i< pStrArray->GetSize();i++)
		m_ComboSpeed.AddString(pStrArray->GetAt(i));

	pStrArray = SerialParams::GetBitsList();
	for (i=0; i< pStrArray->GetSize();i++)
		m_ComboDatabits.AddString(pStrArray->GetAt(i));

	
	i = m_ComboPort.FindString(0,SerialParams::GetDefaultPort());
	m_ComboPort.SetCurSel(i);

	i = m_ComboSpeed.FindString(0,SerialParams::GetDefaultSpeed());
	m_ComboSpeed.SetCurSel(i);

	i = m_ComboDatabits.FindString(0,SerialParams::GetDefaultBits());
	m_ComboDatabits.SetCurSel(i);

	return TRUE;
}

void CDialogChosePort::SetModel(SerialPort& port)
{
	m_port= &port;
}

BEGIN_MESSAGE_MAP(CDialogChosePort, CDialog)
	ON_BN_CLICKED(IDOK, &CDialogChosePort::OnBnClickedOk)
END_MESSAGE_MAP()


// CDialogChosePort message handlers

void CDialogChosePort::OnBnClickedOk()
{
	CString strPort,strSpeed,strBits;
	int i;

	i = m_ComboPort.GetCurSel();
	m_ComboPort.GetLBText( i, strPort);
	m_port->SetPort(strPort.Left(5));
	
	i = m_ComboSpeed.GetCurSel();
	m_ComboSpeed.GetLBText( i, strSpeed);
	m_port->SetSpeed(strSpeed);

	i = m_ComboDatabits.GetCurSel();
	m_ComboDatabits.GetLBText( i, strBits);
	m_port->SetBits(strBits);

	// TODO: Add your control notification handler code here
	OnOK();
}
