// DemoDialerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoDialer.h"
#include "DemoDialerDlg.h"
#include <strsafe.h>
#include "ril.h"


// Include the proper version of TAPI
#define ERR_NONE             
#define REASONABLE_BUFFER_SIZE  512

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HINSTANCE g_hDialogInst; 
CDemoDialerDlg *g_hwndDialerDlg = NULL;

HLINEAPP g_hLineApp = NULL;     // Application's use handle for TAPI

TCHAR g_szCurrentNum[TAPIMAXDESTADDRESSSIZE + 1]; 
// Current phone number
TCHAR g_szLastNum[TAPIMAXDESTADDRESSSIZE + 1];         
// Last called phone number


DWORD g_dwNumDevs = 0;          // Number of line devices available
DWORD g_dwCurrentLineID = -1;   // Current line device identifier
DWORD g_dwCurrentLineAddr = -1; // Current line address


HRIL				g_hRil = 0;
DWORD				g_dwParam = 0x55AA55AA;
DWORD				g_dwLastRingTime = 0;

#define ErrorBox(_s) MessageBox((HWND)g_hwndDialerDlg,_s, \
TEXT("DemoDialer Message"),MB_OK)

#define MUX_COMMAND_DRIVER_PATH L"Drivers\\BuiltIn\\GSM0710_1"
#define MUX_DATA_DRIVER_PATH L"Drivers\\BuiltIn\\GSM0710_2"
#define RIL_DRIVER_PATH L"Drivers\\BuiltIn\\RIL"

HANDLE g_hActivatedDevMux;
HANDLE g_hActivatedDevRil;


// information
// CDemoDialerDlg dialog

DWORD InitializeRIL ();
DWORD DeInitializeRIL ();

CDemoDialerDlg::CDemoDialerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDialerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDialerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_NUMBER, m_CEditPhoneNumber);
	DDX_Control(pDX, IDC_EDIT_STATUS, m_CEditStatus);
}

BEGIN_MESSAGE_MAP(CDemoDialerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CDemoDialerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDemoDialerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDemoDialerDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CDemoDialerDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CDemoDialerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CDemoDialerDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CDemoDialerDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CDemoDialerDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CDemoDialerDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CDemoDialerDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, &CDemoDialerDlg::OnBnClickedButton11)
	ON_BN_CLICKED(IDC_BUTTON12, &CDemoDialerDlg::OnBnClickedButton12)
	ON_BN_CLICKED(IDC_BUTTON_DIAL, &CDemoDialerDlg::OnBnClickedButtonDial)
	ON_BN_CLICKED(IDC_BUTTON_HANG, &CDemoDialerDlg::OnBnClickedButtonHang)
	ON_BN_CLICKED(IDC_BUTTON_CLEAN, &CDemoDialerDlg::OnBnClickedButtonClean)
END_MESSAGE_MAP()


// CDemoDialerDlg message handlers

void CDemoDialerDlg::OnOK()
{
	BOOL bRes;

	DeInitializeRIL();
	if (g_hActivatedDevRil) {
	
		bRes = DeactivateDevice(g_hActivatedDevRil);
		g_hActivatedDevRil = NULL;
	}

	if (g_hActivatedDevMux) {
		bRes = DeactivateDevice(g_hActivatedDevMux);
		g_hActivatedDevMux = NULL;
	}
	CDialog::OnOK();
}
void CDemoDialerDlg::OnCancel()
{
	BOOL bRes;

	DeInitializeRIL();
	if (g_hActivatedDevRil) {
	
		bRes = DeactivateDevice(g_hActivatedDevRil);
		g_hActivatedDevRil = NULL;
	}

	if (g_hActivatedDevMux) {
		bRes = DeactivateDevice(g_hActivatedDevMux);
		g_hActivatedDevMux = NULL;
	}

	CDialog::OnCancel();
}

BOOL CDemoDialerDlg::OnInitDialog()
{	
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	g_hwndDialerDlg = this;

    if (InitializeRIL ())
    {
		this->MessageBoxW(TEXT("Intilization of Ril.dll failed."),TEXT("DemoDialer Message"),MB_OK);
		return FALSE;
    }
            
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CDemoDialerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_DEMODIALER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_DEMODIALER_DIALOG));
	}
}
#endif


void CDemoDialerDlg::OnBnClickedButton1()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"1");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton2()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"2");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton3()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"3");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton4()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"4");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton5()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"5");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton6()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"6");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton7()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"7");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton8()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"8");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton9()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"9");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton10()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"*");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton11()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"0");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButton12()
{
	CString l_strValue; 
	m_CEditPhoneNumber.GetWindowText(l_strValue);
	l_strValue.Append(L"#");
	m_CEditPhoneNumber.SetWindowText(l_strValue);
}

void CDemoDialerDlg::OnBnClickedButtonDial()
{
	TCHAR g_szTemp[256]; 
	g_dwCurrentLineID = 0;

	//Check for the Ring indication during the last 10 sec
	DWORD dwTicks =GetTickCount();
	if ((DWORD)(dwTicks - g_dwLastRingTime) < 10000)
		AnswerPhoneCall();
	else { 	

		m_CEditPhoneNumber.GetWindowTextW(g_szCurrentNum,80L);

		wsprintf(g_szTemp,L"Dialing %s ...",g_szCurrentNum);
		m_CEditStatus.SetWindowTextW(g_szTemp);
		// Make the call.
		MakePhoneCall (g_szCurrentNum);

		this->GetDlgItem(IDC_EDIT_NUMBER)->SetFocus();
		this->GetDlgItem(IDC_EDIT_NUMBER)->SendMessage(EM_SETSEL,0, -1);
		this->GetDlgItem(IDC_BUTTON_DIAL)->EnableWindow(FALSE); 
		// Save the phone number in the g_szLastNum string.
		lstrcpy (g_szLastNum, g_szCurrentNum);
	}
}

void CDemoDialerDlg::OnBnClickedButtonHang()
{
	// Close the current phone line.
	HangupCall();
	this->GetDlgItem(IDC_BUTTON_DIAL)->EnableWindow(TRUE); 
}

void CDemoDialerDlg::OnBnClickedButtonClean()
{
	m_CEditPhoneNumber.SetWindowTextW(L"");
}


BOOL CDemoDialerDlg::InitDialogInstance(HINSTANCE hInstance)
{
	g_hDialogInst = hInstance;
	return TRUE;
}


TCHAR * RilNClassString(DWORD code)
{
    switch(NCLASS_FROM_NOTIFICATION(code))
    {
		case RIL_NCLASS_FUNCRESULT  : return L"FUNCRESULT";
		case RIL_NCLASS_CALLCTRL    : return L"CALLCTRL";
		case RIL_NCLASS_MESSAGE     : return L"MESSAGE";
		case RIL_NCLASS_NETWORK     : return L"NETWORK";
		case RIL_NCLASS_SUPSERVICE  : return L"SUPSERVICE";
		case RIL_NCLASS_PHONEBOOK   : return L"PHONEBOOK";
		case RIL_NCLASS_SIMTOOLKIT  : return L"SIMTOOLKIT";
		case RIL_NCLASS_MISC        : return L"MISC";
		case RIL_NCLASS_RADIOSTATE  : return L"RADIOSTATE";
		case RIL_NCLASS_DEVSPECIFIC : return L"DEVSPECIFIC";
		default:
			return L"UNKNOWN NCLASS";
    }
}

TCHAR *RilResultString(HRESULT res)
{
    switch(res)
    {

		case RIL_RESULT_OK:                               return L"FUNCRESULT::OK";
		case RIL_RESULT_NOCARRIER:                        return L"FUNCRESULT::NOCARRIER";
		case RIL_RESULT_ERROR:                            return L"FUNCRESULT::ERROR";
		case RIL_RESULT_NODIALTONE:                       return L"FUNCRESULT::NODIALTONE";
		case RIL_RESULT_BUSY:                             return L"FUNCRESULT::BUSY";
		case RIL_RESULT_NOANSWER:                         return L"FUNCRESULT::NOANSWER";
		case RIL_RESULT_CALLABORTED:                      return L"FUNCRESULT::CALLABORTED";

		case RIL_NOTIFY_RING:                             return L"CALLCTRL::RING";
		case RIL_NOTIFY_CONNECT:                          return L"CALLCTRL::CONNECT";
		case RIL_NOTIFY_DISCONNECT:                       return L"CALLCTRL::DISCONNECT";
		case RIL_NOTIFY_DATASVCNEGOTIATED:                return L"CALLCTRL::DATASVCNEGOTIATED";
		case RIL_NOTIFY_CALLSTATECHANGED:                 return L"CALLCTRL::CALLSTATECHANGED";
		case RIL_NOTIFY_EMERGENCYMODEENTERED:             return L"CALLCTRL::EMERGENCYMODEENTERED";
		case RIL_NOTIFY_EMERGENCYMODEEXITED:              return L"CALLCTRL::EMERGENCYMODEEXITED";
		case RIL_NOTIFY_EMERGENCYHANGUP:                  return L"CALLCTRL::EMERGENCYHANGUP";
		case RIL_NOTIFY_HSCSDPARAMSNEGOTIATED:            return L"CALLCTRL::HSCSDPARAMSNEGOTIATED";
		case RIL_NOTIFY_DIAL:                             return L"CALLCTRL::DIAL";
		case RIL_NOTIFY_CALLPROGRESSINFO:                 return L"CALLCTRL::CALLPROGRESSINFO";
		case RIL_NOTIFY_CURRENTLINECHANGED:               return L"CALLCTRL::CURRENTLINECHANGED";
		case RIL_NOTIFY_GPRS_DISCONNECT:                  return L"CALLCTRL::GPRS_DISCONNECT";

		case RIL_NOTIFY_MESSAGE:                          return L"MESSAGE::MESSAGE";
		case RIL_NOTIFY_BCMESSAGE:                        return L"MESSAGE::BCMESSAGE";
		case RIL_NOTIFY_STATUSMESSAGE:                    return L"MESSAGE::STATUSMESSAGE";
		case RIL_NOTIFY_MSGSTORED:                        return L"MESSAGE::MSGSTORED";
		case RIL_NOTIFY_MSGDELETED:                       return L"MESSAGE::MSGDELETED";
		case RIL_NOTIFY_MSGSTORAGECHANGED:                return L"MESSAGE::MSGSTORAGECHANGED";
		case RIL_NOTIFY_MESSAGE_IN_SIM:                   return L"MESSAGE::MESSAGE_IN_SIM";
		case RIL_NOTIFY_BCMESSAGE_IN_SIM:                 return L"MESSAGE::BCMESSAGE_IN_SIM";
		case RIL_NOTIFY_STATUSMESSAGE_IN_SIM:             return L"MESSAGE::STATUSMESSAGE_IN_SIM";

		case RIL_NOTIFY_REGSTATUSCHANGED:                 return L"NETWORK::REGSTATUSCHANGED";
		case RIL_NOTIFY_CALLMETER:                        return L"NETWORK::CALLMETER";
		case RIL_NOTIFY_CALLMETERMAXREACHED:              return L"NETWORK::CALLMETERMAXREACHED";
		case RIL_NOTIFY_GPRSREGSTATUSCHANGED:             return L"NETWORK::GPRSREGSTATUSCHANGED";
		case RIL_NOTIFY_SYSTEMCHANGED:                    return L"NETWORK::SYSTEMCHANGED";
		case (0x00000008 | RIL_NCLASS_NETWORK):           return L"NETWORK::LOCATIONINFO";

		case RIL_NOTIFY_CALLERID:                         return L"SUPSERVICE::CALLERID";
		case RIL_NOTIFY_DIALEDID:                         return L"SUPSERVICE::DIALEDID";
		case RIL_NOTIFY_CALLWAITING:                      return L"SUPSERVICE::CALLWAITING";
		case RIL_NOTIFY_SUPSERVICEDATA:                   return L"SUPSERVICE::SUPSERVICEDATA";
		case RIL_NOTIFY_INTERMEDIATESS:                   return L"SUPSERVICE::INTERMEDIATESS";
		case RIL_NOTIFY_UNSOLICITEDSS :                   return L"SUPSERVICE::UNSOLICITEDSS";

		case RIL_NOTIFY_PHONEBOOKENTRYSTORED:             return L"PHONEBOOK::PHONEBOOKENTRYSTORED";
		case RIL_NOTIFY_PHONEBOOKENTRYDELETED:            return L"PHONEBOOK::PHONEBOOKENTRYDELETED";
		case RIL_NOTIFY_PHONEBOOKSTORAGECHANGED:          return L"PHONEBOOK::PHONEBOOKSTORAGECHANGED";

		case RIL_NOTIFY_SIMTOOLKITCMD:                    return L"SIMTOOLKIT::SIMTOOLKITCMD";
		case RIL_NOTIFY_SIMTOOLKITCALLSETUP:              return L"SIMTOOLKIT::SIMTOOLKITCALLSETUP";
		case RIL_NOTIFY_SIMTOOLKITEVENT:                  return L"SIMTOOLKIT::SIMTOOLKITEVENT";
		case RIL_NOTIFY_SIMTOOLKITSESSIONEND:             return L"SIMTOOLKIT::SIMTOOLKITSESSIONEND";

		case RIL_NOTIFY_RADIOEQUIPMENTSTATECHANGED:       return L"RADIOSTATE::RADIOEQUIPMENTSTATECHANGED";
		case RIL_NOTIFY_RADIOPRESENCECHANGED:             return L"RADIOSTATE::RADIOPRESENCECHANGED";

		case RIL_NOTIFY_SIMNOTACCESSIBLE:                 return L"MISC::SIMNOTACCESSIBLE";
		case RIL_NOTIFY_DTMFSIGNAL:                       return L"MISC::DTMFSIGNAL";
		case RIL_NOTIFY_GPRSCLASS_NETWORKCHANGED:         return L"MISC::GPRSCLASS_NETWORKCHANGED";
		case RIL_NOTIFY_GPRSCLASS_RADIOCHANGED:           return L"MISC::GPRSCLASS_RADIOCHANGED";
		case RIL_NOTIFY_SIGNALQUALITY:                    return L"MISC::SIGNALQUALITY";

		case RIL_NOTIFY_MAINTREQUIRED   :                    return L"MISC::MAINTREQUIRED";
		case RIL_NOTIFY_PRIVACYCHANGED  :                    return L"MISC::PRIVACYCHANGED";
		case RIL_NOTIFY_SIM_DATACHANGE  :                    return L"MISC::SIM_DATACHANGE";
		case RIL_NOTIFY_ATLOGGING       :                    return L"MISC::ATLOGGING";
		case RIL_NOTIFY_SIMSTATUSCHANGED:                    return L"MISC::SIMSTATUSCHANGED";

		default:
			return L"UNKNOWN NOTIFY CODE";
	}
}

void CALLBACK NotifyCallback(DWORD dwCode, const void *lpData, 
										   DWORD cbData, DWORD dwParam)
{
	TCHAR szString[256];
	wsprintf(szString, L"%s notify: dwCode=0x%0X lpData=%p, cbData=%d",RilResultString(dwCode),dwCode, lpData, cbData);
	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	//wsprintf(L"NotifyCallback: %s",szString);
	
	switch(NCLASS_FROM_NOTIFICATION(dwCode))
	{
		case RIL_NCLASS_CALLCTRL  :

			if (dwCode & RIL_NOTIFY_RING)
			{
				RILRINGINFO *p_stRingInfo = (RILRINGINFO *)lpData;
				// Check for the incoming call condition
				if (p_stRingInfo->dwParams == 5)
					g_dwLastRingTime = GetTickCount();
				break;
			}
			else if (dwCode & RIL_NOTIFY_CALLPROGRESSINFO){
				break;
			}
	}

}

void CALLBACK ResultCallback(DWORD dwCode, HRESULT hrCmdID,		const void *lpData, 
										   DWORD cbData, DWORD dwParam)
{
	TCHAR szString[256];

	wsprintf(szString, L"result: dwCode=%d, hrCmdID=%d lpData=%p, cbData=%d",dwCode,
		hrCmdID, lpData, cbData);
	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
}


/***********************************************************************
      
FUNCTION: 
InitializeRIL 

PURPOSE:  
Initialize the application's use of RIL.
          
***********************************************************************/
DWORD InitializeRIL ()
{
	DWORD dwResult;
	TCHAR szString[256];
    
	// Listern to all RIL notification clases
	DWORD dwNotificationClasses = 0xFFFFFFFF;

	dwResult = RIL_Initialize(1, ResultCallback, NotifyCallback,
					   dwNotificationClasses, g_dwParam, &g_hRil);
	wsprintf(szString, L"RIL Handle: %08X, result %08X", g_hRil, dwResult);
	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	return dwResult;
    
}

DWORD DeInitializeRIL ()
{
	DWORD dwResult;
	TCHAR szString[256];
    
	dwResult = RIL_Deinitialize(g_hRil);
	wsprintf(szString, L"RIL Handle: %08X, result %08X", g_hRil, dwResult);
	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	return dwResult;
    
}

/***********************************************************************
            
FUNCTION: 
MakePhoneCall 

***********************************************************************/
VOID MakePhoneCall (LPCTSTR lpszPhoneNum)
{
    HRESULT hr;
	TCHAR szString[256];

	USES_CONVERSION;
	hr = RIL_Dial(g_hRil,T2A(lpszPhoneNum),RIL_CALLTYPE_VOICE,RIL_DIALOPT_PRESENTID);

	wsprintf(szString, L"Dialing  %s",lpszPhoneNum);
	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	if (IS_ERROR(hr)) {
		wsprintf(szString, L"RIL_Dial Error: %08X",hr);
		g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	}
    return;
}

VOID AnswerPhoneCall ()
{
    HRESULT hr;
	TCHAR szString[256];

	hr = RIL_Answer(g_hRil);

	if (IS_ERROR(hr)) {
		wsprintf(szString, L"RIL_Answer Error: %08X",hr);
		g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
	}
    return;
}


/***********************************************************************
            
FUNCTION: 
StopPhoneCall 

***********************************************************************/
VOID HangupCall ()
{
	TCHAR szString[256];
	HRESULT hr= RIL_Hangup(g_hRil);

	g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(L"Hanging up...");

    if (IS_ERROR(hr)) {
        wsprintf(szString, L"RIL_Hangup Error: %08X",hr);
		g_hwndDialerDlg->m_CEditStatus.SetWindowTextW(szString);
    }
	
    return;
}
